/*
 *	TOPPERS/ASP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *								Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2001-2009 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	$Id: prc_config.c 1824 2010-07-02 06:50:03Z mit-kimai $
 */

/*
 *		ץå¸⥸塼SH12Aѡ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 * ƥȻȤΤѿ
 */
uint32_t excnest_count; /* 㳰ʳ/CPU㳰ˤΥͥȲΥ */

/*
 *	CPUåե饰¸Τѿ
 */
bool_t		lock_flag;		/* CPUåե饰ͤݻѿ */
uint32_t	saved_iipm;		/* ͥ٥ޥ¸ѿ */

/*
 *	ƳֹIPRξơ֥
 *	Ƥϡץå˰ۤʤΤᡤ
 *	ץåե
 */
const IPR_INFO ipr_info_tbl[TNUM_INH] = {
	IPR_INFO_TBL_DATA
};

/*
 *	ͥΥ٥
 */
extern const FP vectors;

/*
 *	ץå¸ν
 */
void
prc_initialize(void)
{
   /*
	*  ͥ뵯ư󥿥ƥȤȤư뤿ᡢ
	*  1ˤƤ
	*/
	excnest_count = 1U;
	
	/*
	 *	CPUåե饰¸Τѿν
	 */
	lock_flag = true;
	saved_iipm = IIPM_ENAALL;
	
	/*
	 *	ߥȥν
	 *	ץå
	 */
	irc_initialize();

	/*
	 *	٥١쥸ν
	 */
	set_vbr((void *)&vectors);
}

/*
 *	ץå¸νλ
 */
void
prc_exit(void)
{
	extern void    software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *	software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *	ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *	Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}
}

/*
 *	׵饤°
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
	assert(VALID_INTNO_CFGINT(intno));
	assert((-15 <= intpri) && (intpri <= TMAX_INTPRI));

	/*
	 *	öߤػߤ
	 */
	(void)x_disable_int(intno);

	/*
	 *	٥ȥꥬ/åȥꥬ
	 */
	x_config_intatr(intno, intatr);

	/*
	 *	׵ޥ(ɬפʾ)
	 *	Ʊ˳ͥ٤⥻åȤ
	 */
	if ((intatr & TA_ENAINT) != 0U) {
		(void) x_enable_int(intno);
	}
}


#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 *	ϿƤʤ㳰ȯȸƤӽФ
 */
void
default_exc_handler(void *p_excinf)
{
	uint32_t *sp	= (uint32_t*)p_excinf;
	uint32_t vector = *(sp + P_EXCINF_OFFSET_VECTOR);
	uint32_t pc 	= *(sp + P_EXCINF_OFFSET_PC);
	uint32_t sr 	= *(sp + P_EXCINF_OFFSET_SR);
	uint32_t pr 	= *(sp + P_EXCINF_OFFSET_PR);
	uint32_t *sp_val = sp + P_EXCINF_OFFSET_SP;
	uint32_t reg, i;
	char 	 *msg;
	
	switch(vector) {
		case GENERAL_ILLEGAL_INSTRUCTION_VECTOR:
			msg = "General illegal instruction exception occurs.";
			break;
		case RAM_ERROR_VECTOR:
			msg = "RAM error exception occurs.";
			break;
		case SLOT_ILLEGAL_INSTRUCTION_VECTOR:
			msg = "Slot illegal instruction exception occurs.";
			break;
		case CPU_ADDRESS_ERROR_VECTOR:
			msg = "CPU address error exception occurs.";
			break;
		case DMA_ADDRESS_ERROR_VECTOR:
			msg = "DMA address error exception occurs.";
			break;

#ifdef FPU_VECTOR
		case FPU_VECTOR:
			msg = "FPU exception occurs.";
			break;
#endif /*  FPU_VECTOR  */

#ifdef SH2A
		case BANK_OVER_FLOW_VECTOR:
			msg = "Bank over flow exception occurs.";
			break;
		case BANK_UNDER_FLOW_VECTOR:
			msg = "Bank under flow exception occurs.";
			break;
#endif /*  SH2A  */

		default:
   			msg = "Unregistered Expevt error occurs.";
   			break;
   	}
	syslog_1(LOG_EMERG, "%s", msg);

	syslog_3(LOG_EMERG, "VectorNo = %d PC = 0x%08x SP = 0x%08p",
		   vector, pc, sp_val);
	syslog_2(LOG_EMERG, "SR = 0x%08x PR=0x%08x", sr, pr);
	for(i = 0; i < 8; ++i) {
		reg = *(sp + P_EXCINF_OFFSET_R0 + i);
		syslog_2(LOG_EMERG, " r%d=0x%08x", i, reg);
	}
	target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *	̤Ͽγߤȯ˸ƤӽФ
 */
void
default_int_handler(INTNO intno)
{
	syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
	syslog_1(LOG_EMERG, "INTNO = %d",intno);
	target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
