/*
 *	TOPPERS Software
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *								Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	$Id: prc_insn.h 1824 2010-07-02 06:50:03Z mit-kimai $
 */

/*
 *	ץåü̿Υ饤ؿSH12Aѡ
 */

#ifndef TOPPERS_PRC_INSN_H
#define TOPPERS_PRC_INSN_H

/*
 *	ơ쥸SRˤθͤɽФ
 */
Inline uint32_t
current_sr(void)
{
	uint32_t sr;
	Asm("stc  sr,%0" : "=r"(sr));
	return(sr);
}

/*
 *	ơ쥸SRˤθͤѹ
 */
Inline void
set_sr(uint32_t sr)
{
	Asm("ldc %0, sr" : : "r"(sr) : "t");
}

#ifdef LDC_NOP_SET_SR
Inline void
set_sr_with_nop(uint32_t sr)
{
	Asm("ldc %0, sr;"
		LDC_NOP_SET_SR			/*  CPUINTCãޤǤٱ  */
		 : : "r"(sr) : "t");
}
#endif	/*  LDC_NOP_SET_SR  */

/*
 *	٥١쥸VBRˤθͤɽФ
 */
Inline void *
current_vbr(void)
{
	void *vbr;
	Asm("stc vbr,%0" : "=r"(vbr));
	return(vbr);
}

/*
 *	٥١쥸VBRˤ
 */
Inline void
set_vbr(void *vbr)
{
	Asm("ldc  %0, vbr" : : "r"(vbr) );
}

#endif /* TOPPERS_PRC_INSN_H */
